#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "libetm.h"

/* when using atof(), don't forget #include <stdlib.h> or big bugs to come */
int main(int argc, char *argv[])
{
	float		n;
	char		str[] = "#one t##wo three ###fou#r five six se###ven e#ight nine ten eleven twel#ve#";
	const char	str1[] = "look for CHKFILE1 and if found replace it with CHKFILE2 which includes\n"
				"£%$^^*(&(*_)(8987465|```'@:?><|¬!\"&*(+_)(*&^%$£\"!{}~#][';=-/.,`\|`|\|\n"
				"mixed up computed timeout and key\n"
				"if not found, look for CHKFILE2 then unmixed and checked timeout and key\n"
				"so CHKFILE1 must be there alone after install";
	const char	*key= "708wngvukNkxsBG7HlYRwBJJ2HQJ07s55ABrQ5V9SdFiPjpuFlk0W2TXJHEHN6LSFkhtpbBfofxbyWGbf0l00c6ITJnEO8urrMUQXu4jJBvfv0rL8MU7YZPPHarthWVJ";
	char		*str2, *str3, *str4;
	char		str5[64], salt[16];

	printf("testing again...\n");
	if (argc == 2)
		n = atof((const char *)argv[1]);
	else
		n = 3409809,9453297;
	printf("testing APPROX()\n");
	printf("n = %.02f\nSIGN(n) = %d\nAPPROX(n) = %d\n", n, SIGN(n), APPROX(n));

	if (FALSE/*question("next one")*/) {
		printf("\ntesting remove_char_from_str(str, '#')\n");
		printf("str =\n1- %s\n", str);
		remove_char_from_str(str, '#');
		printf("2- %s\n", str);
	}

	if (FALSE/*question("next one")*/) {
		printf("\ntesting str_crypt(str, key)\n");
		printf("str1 = %s\n\n", str1);
		str2 = (char *)str_crypt(str1, key);
		printf("str2 = %s\n\n", str2);
		str3 = (char *)str_crypt(str2, key);
		printf("str3 = %s\n\n", str3);
	}

	if (FALSE/*question("next one")*/) {
		printf("\ntesting rnd_str(mode, length)\n");
		printf("rnd_str('a', 64) = %s\n", rnd_str('a', 64));
		printf("rnd_str('d', 64) = %s\n", rnd_str('d', 64));
		printf("rnd_str('b', 2048) = %s\n", (str4 = (char *)rnd_str('b', 2048)));
		printf("strlen(str) = %d\n", strlen(str4));
	}

	if (TRUE/*question("next one")*/) {
		printf("\ntesting str_crypto_hash(str, salt)\n\n");
		str_n_cpy(str5, "hello !!!!", 63);
		str_n_cpy(salt, "123456", 15);
		printf("str = %s\nsalt = %s\nhash = %ld\n\n", str5, salt, str_crypto_hash(str5, salt));

		str_n_cpy(str5, "ldslkjfglkjfglkdskldsgkl", 63);
		str_n_cpy(salt, "123456", 15);
		printf("str = %s\nsalt = %s\nhash = %ld\n\n", str5, salt, str_crypto_hash(str5, salt));

		str_n_cpy(str5, "hello !!", 63);
		str_n_cpy(salt, "123456", 15);
		printf("str = %s\nsalt = %s\nhash = %ld\n\n", str5, salt, str_crypto_hash(str5, salt));

		str_n_cpy(str5, "lkdsflkdfs9850985460985-5-034", 63);
		str_n_cpy(salt, "123456", 15);
		printf("str = %s\nsalt = %s\nhash = %ld\n\n", str5, salt, str_crypto_hash(str5, salt));
	}
	return 0;
}

int big_error(int code, const char *s1, const char *s2, const char *s3, const char *s4)
{
	printf("big error somewhere...\n");
	exit(code);
}
